/***************************************************************************
 *   Copyright (C) 2001 by Rick L. Vinyard, Jr.                            *
 *   rvinyard@cs.nmsu.edu                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Lesser General Public License as        *
 *   published by the Free Software Foundation version 2.1.                *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU Lesser General Public      *
 *   License along with this library; if not, write to the                 *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA              *
 ***************************************************************************/
#include "address.h"

#include <cstring>

namespace Conexus {

Address::Address() {
  memset(&m_sockaddr_storage, 0x00, sizeof(m_sockaddr_storage));
}

Address::Address(const struct sockaddr_storage& addr) {
  memcpy(&m_sockaddr_storage, &addr, sizeof(struct sockaddr_storage));
}


Address::~Address() {}

struct sockaddr* Address::sockaddr_ptr() {
  return (struct sockaddr*)&m_sockaddr_storage;
}

socklen_t Address::sockaddr_size() const {
  return sizeof(struct sockaddr_storage);
}

bool Address::is_broadcast() const {
    return false;
}


}
